Package org.eclipse.rdf4j.query.algebra.helpers

## Class AbstractQueryModelVisitor<X extends Exception>

- java.lang.Object
- - org.eclipse.rdf4j.query.algebra.helpers.AbstractQueryModelVisitor<X>

- All Implemented Interfaces:
    `QueryModelVisitor<X>`
  Direct Known Subclasses:
    `BaseTupleExprRenderer`, `BindingAssigner.VarVisitor`, `CompareOptimizer.CompareVisitor`, `ConjunctiveConstraintSplitter.ConstraintVisitor`, `ConstantOptimizer.VarNameCollector`, `ContextCollector`, `DisjunctiveConstraintOptimizer.OrSameTermOptimizer`, `EmptyPatternOptimizer`, `EvaluationStatistics.CardinalityCalculator`, `EvaluationStatistics.CardinalityCalculator`, `ExclusiveTupleExprOptimizer`, `FederationJoinOptimizer`, `FilterOptimizer`, `FilterOptimizer.DeMergeFilterFinder`, `FilterOptimizer.FilterBindingFinder`, `FilterOptimizer.FilterExprInsertVisitor`, `FilterOptimizer.FilterFinder`, `FilterOptimizer.FilterRelocator`, `FilterOptimizer.MergeFilterFinder`, `FilterOptimizer.VarFinder`, `GenericInfoOptimizer`, `IterativeEvaluationOptimizer.IEOVisitor`, `LimitOptimizer`, `OrderLimitOptimizer.OrderOptimizer`, `OwnedTupleExprPruner`, `PrepareOwnedTupleExpr`, `QueryJoinOptimizer.JoinVisitor`, `QueryModelNodeReplacer`, `QueryModelNormalizer`, `QueryModelPruner.TreeSanitizer`, `QueryModelPruner.TreeSanitizer`, `QueryModelTreePrinter`, `QueryModelTreeToGenericPlanNode`, `QueryModelVisitorBase`, `QueryMultiJoinOptimizer.JoinVisitor`, `RegexAsStringFunctionOptimizer.RegexAsStringFunctionVisitor`, `SameTermFilterOptimizer.BindingSetAssignmentCollector`, `SameTermFilterOptimizer.SameTermFilterVisitor`, `SameTermFilterOptimizer.VarBinder`, `SameTermFilterOptimizer.VarRenamer`, `ServiceOptimizer`, `StatementGroupAndJoinOptimizer`, `StatementPatternCollector`, `TripleRefCollector`, `TupleExprBuilder.SameTermCollector`, `TupleExprBuilder.VarCollector`, `UnionOptimizer`, `VarNameCollector`

      public abstract class AbstractQueryModelVisitor<X extends Exception>
      extends Object
      implements QueryModelVisitor<X>

  Base class for `QueryModelVisitor`s. This class implements all meet(... node) methods from the visitor interface, forwarding the call to a method for the node's supertype. This is done recursively until `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` is reached. This allows subclasses to easily define default behaviour for visited nodes of a certain type. The default implementation of `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` is to visit the node's children.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractQueryModelVisitor()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `meet​(Add node)` |
    `void` | `meet​(And node)` |
    `void` | `meet​(ArbitraryLengthPath node)` |
    `void` | `meet​(Avg node)` |
    `void` | `meet​(BindingSetAssignment node)` |
    `void` | `meet​(BNodeGenerator node)` |
    `void` | `meet​(Bound node)` |
    `void` | `meet​(Clear node)` |
    `void` | `meet​(Coalesce node)` |
    `void` | `meet​(Compare node)` |
    `void` | `meet​(CompareAll node)` |
    `void` | `meet​(CompareAny node)` |
    `void` | `meet​(Copy node)` |
    `void` | `meet​(Count node)` |
    `void` | `meet​(Create node)` |
    `void` | `meet​(Datatype node)` |
    `void` | `meet​(DeleteData node)` |
    `void` | `meet​(DescribeOperator node)` |
    `void` | `meet​(Difference node)` |
    `void` | `meet​(Distinct node)` |
    `void` | `meet​(EmptySet node)` |
    `void` | `meet​(Exists node)` |
    `void` | `meet​(Extension node)` |
    `void` | `meet​(ExtensionElem node)` |
    `void` | `meet​(Filter node)` |
    `void` | `meet​(FunctionCall node)` |
    `void` | `meet​(Group node)` |
    `void` | `meet​(GroupConcat node)` |
    `void` | `meet​(GroupElem node)` |
    `void` | `meet​(If node)` |
    `void` | `meet​(In node)` |
    `void` | `meet​(InsertData node)` |
    `void` | `meet​(Intersection node)` |
    `void` | `meet​(IRIFunction node)` |
    `void` | `meet​(IsBNode node)` |
    `void` | `meet​(IsLiteral node)` |
    `void` | `meet​(IsNumeric node)` |
    `void` | `meet​(IsResource node)` |
    `void` | `meet​(IsURI node)` |
    `void` | `meet​(Join node)` |
    `void` | `meet​(Label node)` |
    `void` | `meet​(Lang node)` |
    `void` | `meet​(LangMatches node)` |
    `void` | `meet​(LeftJoin node)` |
    `void` | `meet​(Like node)` |
    `void` | `meet​(ListMemberOperator node)` |
    `void` | `meet​(Load node)` |
    `void` | `meet​(LocalName node)` |
    `void` | `meet​(MathExpr node)` |
    `void` | `meet​(Max node)` |
    `void` | `meet​(Min node)` |
    `void` | `meet​(Modify node)` |
    `void` | `meet​(Move node)` |
    `void` | `meet​(MultiProjection node)` |
    `void` | `meet​(Namespace node)` |
    `void` | `meet​(Not node)` |
    `void` | `meet​(Or node)` |
    `void` | `meet​(Order node)` |
    `void` | `meet​(OrderElem node)` |
    `void` | `meet​(Projection node)` |
    `void` | `meet​(ProjectionElem node)` |
    `void` | `meet​(ProjectionElemList node)` |
    `void` | `meet​(QueryRoot node)` |
    `void` | `meet​(Reduced node)` |
    `void` | `meet​(Regex node)` |
    `void` | `meet​(SameTerm node)` |
    `void` | `meet​(Sample node)` |
    `void` | `meet​(Service node)` |
    `void` | `meet​(SingletonSet node)` |
    `void` | `meet​(Slice node)` |
    `void` | `meet​(StatementPattern node)` |
    `void` | `meet​(Str node)` |
    `void` | `meet​(Sum node)` |
    `void` | `meet​(TripleRef node)` |
    `void` | `meet​(Union node)` |
    `void` | `meet​(ValueConstant node)` |
    `void` | `meet​(ValueExprTripleRef node)` |
    `void` | `meet​(Var node)` |
    `void` | `meet​(ZeroLengthPath node)` |
    `protected void` | `meetBinaryTupleOperator​(BinaryTupleOperator node)` | Method called by all meet methods with a `BinaryTupleOperator` node as argument.
    `protected void` | `meetBinaryValueOperator​(BinaryValueOperator node)` | Method called by all meet methods with a `BinaryValueOperator` node as argument.
    `protected void` | `meetCompareSubQueryValueOperator​(CompareSubQueryValueOperator node)` | Method called by all meet methods with a `CompareSubQueryValueOperator` node as argument.
    `protected void` | `meetNAryValueOperator​(NAryValueOperator node)` | Method called by all meet methods with a `NAryValueOperator` node as argument.
    `protected void` | `meetNode​(QueryModelNode node)` | Method called by all of the other meet methods that are not overridden in subclasses.
    `void` | `meetOther​(QueryModelNode node)` |
    `protected void` | `meetSubQueryValueOperator​(SubQueryValueOperator node)` | Method called by all meet methods with a `SubQueryValueOperator` node as argument.
    `protected void` | `meetUnaryTupleOperator​(UnaryTupleOperator node)` | Method called by all meet methods with a `UnaryTupleOperator` node as argument.
    `protected void` | `meetUnaryValueOperator​(UnaryValueOperator node)` | Method called by all meet methods with a `UnaryValueOperator` node as argument.
    `protected void` | `meetUpdateExpr​(UpdateExpr node)` | Method called by all meet methods with a `UpdateExpr` node as argument.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractQueryModelVisitor

          public AbstractQueryModelVisitor()

  - ### Method Detail

    - #### meet

          public void meet​(Add node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(And node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ArbitraryLengthPath node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Avg node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(BindingSetAssignment node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(BNodeGenerator node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Bound node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Clear node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Coalesce node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Compare node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(CompareAll node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(CompareAny node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(DescribeOperator node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Copy node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Count node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Create node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Datatype node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(DeleteData node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Difference node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Distinct node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(EmptySet node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Exists node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Extension node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ExtensionElem node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Filter node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(FunctionCall node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Group node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(GroupConcat node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(GroupElem node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(If node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(In node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(InsertData node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Intersection node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(IRIFunction node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(IsBNode node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(IsLiteral node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(IsNumeric node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(IsResource node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(IsURI node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Join node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Label node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Lang node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(LangMatches node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(LeftJoin node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Like node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Load node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(LocalName node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(MathExpr node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Max node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Min node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Modify node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Move node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(MultiProjection node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Namespace node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Not node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Or node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Order node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(OrderElem node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Projection node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ProjectionElem node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ProjectionElemList node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(QueryRoot node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Reduced node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Regex node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(SameTerm node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Sample node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Service node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(SingletonSet node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Slice node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(StatementPattern node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Str node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Sum node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Union node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ValueConstant node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ListMemberOperator node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(Var node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ZeroLengthPath node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(TripleRef node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meet

          public void meet​(ValueExprTripleRef node)
                    throws X extends Exception

      Specified by:
        `meet` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meetOther

          public void meetOther​(QueryModelNode node)
                         throws X extends Exception

      Specified by:
        `meetOther` in interface `QueryModelVisitor<X extends Exception>`
      Throws:
        `X extends Exception`

    - #### meetBinaryTupleOperator

          protected void meetBinaryTupleOperator​(BinaryTupleOperator node)
                                          throws X extends Exception

      Method called by all meet methods with a `BinaryTupleOperator` node as argument. Forwards the call to `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetBinaryValueOperator

          protected void meetBinaryValueOperator​(BinaryValueOperator node)
                                          throws X extends Exception

      Method called by all meet methods with a `BinaryValueOperator` node as argument. Forwards the call to `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetCompareSubQueryValueOperator

          protected void meetCompareSubQueryValueOperator​(CompareSubQueryValueOperator node)
                                                   throws X extends Exception

      Method called by all meet methods with a `CompareSubQueryValueOperator` node as argument. Forwards the call to `meetSubQueryValueOperator(org.eclipse.rdf4j.query.algebra.SubQueryValueOperator)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetNAryValueOperator

          protected void meetNAryValueOperator​(NAryValueOperator node)
                                        throws X extends Exception

      Method called by all meet methods with a `NAryValueOperator` node as argument. Forwards the call to `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetNode

          protected void meetNode​(QueryModelNode node)
                           throws X extends Exception

      Method called by all of the other meet methods that are not overridden in subclasses. This method can be overridden in subclasses to define default behaviour when visiting nodes. The default behaviour of this method is to visit the node's children.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetSubQueryValueOperator

          protected void meetSubQueryValueOperator​(SubQueryValueOperator node)
                                            throws X extends Exception

      Method called by all meet methods with a `SubQueryValueOperator` node as argument. Forwards the call to `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetUnaryTupleOperator

          protected void meetUnaryTupleOperator​(UnaryTupleOperator node)
                                         throws X extends Exception

      Method called by all meet methods with a `UnaryTupleOperator` node as argument. Forwards the call to `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetUnaryValueOperator

          protected void meetUnaryValueOperator​(UnaryValueOperator node)
                                         throws X extends Exception

      Method called by all meet methods with a `UnaryValueOperator` node as argument. Forwards the call to `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`

    - #### meetUpdateExpr

          protected void meetUpdateExpr​(UpdateExpr node)
                                 throws X extends Exception

      Method called by all meet methods with a `UpdateExpr` node as argument. Forwards the call to `meetNode(org.eclipse.rdf4j.query.algebra.QueryModelNode)` by default.
      Parameters:
        `node` - The node that is being visited.
      Throws:
        `X extends Exception`